import greenfoot.*;
/**
 * Write a description of class Shade here.
 * 
 * @author Taylor Born
 * @version January 2011
 */
import java.util.*;
public class Shade  
{
    private static GreenfootImage pic = new GreenfootImage("virus.png");
    private static GreenfootImage pic2 = new GreenfootImage("virusR.png");
    
    static ControlBox cb;
    static int num;
    static int nextNum;
    
    private int health = 3;
    private double x, y;
    private int direction = Greenfoot.getRandomNumber(360);
    
    private int following;
    private boolean sawLast;
    
    private int reload = 0;
    
    public Shade(int x, int y)
    {
        this.x = x;
        this.y = y;
    }
    
    /*
     * Travel towards Ship's location if in range
     * Or if dead, recover
     */
    public void go(Point p, ControlBox cb)
    {
        if (health < 1)
        {
            if (--health == -2000)
            {
                health = 3;
                following = 0;
            }
        }
        else
        {
            // Distance from Ship
            double dis = Math.sqrt(Math.pow(x - p.getX(), 2) + Math.pow(y - p.getY(), 2));
            
            // Direction to Ship
            int dir = (int)(Math.atan2(p.getY() - y, p.getX() - x) * 180 / Math.PI);
            
            // If there is a straight path without obstacles to the Ship
            boolean inSight = inLineOfSight(p, dir, cb);
            
            if (dis < 200)
            {
                if (inSight)
                {
                    sawLast = true;
                    following = 200;
                    direction = dir;
                    
                    if (dis > 35)
                    {
                        // Move location in set direction if nothing in way
                        double dx = Math.cos(direction * Math.PI / 180) * 4;
                        double dy = Math.sin(direction * Math.PI / 180) * 4;
        //                     if (!cb.checkWall(x + dx + (dx > 0 ? 14 : -14), y + dy + (dy > 0 ? 14 : -14)))
        //                     {
                            x += dx;
                            y += dy;
        //                     }
                    }
                }
            }
            
            if (following > 0)
            {
                if (!inSight || dis >= 200)
                {
                    // find path and start moving on it
                    if (sawLast || (target && routeIndex < 0) || sqrList == null)
                        findPath(new Point(p.getX() - p.getX() % 30, p.getY() - p.getY() % 30), new Point((int)x - (int)x % 30, (int)y - (int)y % 30));
                    sawLast = false;
                    workPath();
                }
                following--;
            }
        }
    }
    
    /*
     * Determine if there is a straight path without obstacles to the Ship
     */
    private boolean inLineOfSight(Point p, int dir, ControlBox cb)
    {
        double lx = x;
        double ly = y;
        double cx = Math.cos(dir * Math.PI / 180) * 5;
        double cy = Math.sin(dir * Math.PI / 180) * 5;
        while (Math.sqrt(Math.pow(p.getX() - lx, 2) + Math.pow(p.getY() - ly, 2)) > 10)
            if (cb.checkWall(lx + cx + (cx > 0 ? 14 : -14), ly + cy + (cy > 0 ? 14 : -14)))
                return false;
            else
            {
                lx += cx;
                ly += cy;
            }
        return true;
    }
    
    private List<Square> sqrList;
    private List<Square> myRoute;
    private int routeIndex;
    private int parent;
    private boolean target;
    private Point targetDestination;
    
    public void findPath(Point pPosition, Point startPosition)
    {
        targetDestination = pPosition; // Get destination
        sqrList = new ArrayList<Square>(); // Refresh my squares to look at
        sqrList.add(new Square(startPosition, -1, 0, 0, targetDestination)); // Add my current position as a square to look at
        target = false; // I have just begun
        parent = 0; // Start at first square
    }
    public void workPath()
    {
//         if (!targetDestination.equals(new Point(getX(), getY()))) // Check to see if already at destination
//         {
            if (!target) // If not done charting course
                makePath(); // Chart it
            else
            {
                // Move toward spot
                Point p = myRoute.get(routeIndex).getPosition();
                direction = (int)(Math.atan2(p.getY() + 15 - y, p.getX() + 15 - x) * 180 / Math.PI);
                x += Math.cos(direction * Math.PI / 180) * 4;
                y += Math.sin(direction * Math.PI / 180) * 4;
                
                // Check if close to spot
                if (Math.sqrt(Math.pow(p.getX() + 15 - x, 2) + Math.pow(p.getY() + 15 - y, 2)) < 10)
                    routeIndex--; // Next spot
            }
//         }
    }
    public void makePath()
    {
        nextNum++;
        for (int q = 0; q < (num > 24 ? 5 : (50 - num * 2)) && !target; q++) // Do so many calculations per act so not to lag other parts of the program
        {
            // Check all squares around the currently looked at square
            // Square to the left
            if (!cb.checkWall(sqrList.get(parent).getPosition().getX() - 30, sqrList.get(parent).getPosition().getY())) // Check if no obstacle
            {
                //if (sqrList.get(parent).getPosition().getX() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 10, new Point(-30, 0))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getPosition().getX() - 30, sqrList.get(parent).getPosition().getY()), parent, sqrList.get(parent).getG(), 10, targetDestination)); // Add the square, takes 10 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            // Square to the upper left
            if (!cb.checkWall(sqrList.get(parent).getPosition().getX() - 30, sqrList.get(parent).getPosition().getY() - 30)) // Check if no obstacle
            {
                //if (sqrList.get(parent).getPosition().getX() - 1 > -1 && sqrList.get(parent).getPosition().getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(-30, -30))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getPosition().getX() - 30, sqrList.get(parent).getPosition().getY() - 30), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            // Square above
            if (!cb.checkWall(sqrList.get(parent).getPosition().getX(), sqrList.get(parent).getPosition().getY() - 30)) // Check if no obstacle
            {
               // if (sqrList.get(parent).getPosition().getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 10, new Point(0, -30))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getPosition().getX(), sqrList.get(parent).getPosition().getY() - 30), parent, sqrList.get(parent).getG(), 10, targetDestination)); // Add the square, takes 10 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            // Square to the upper right
            if (!cb.checkWall(sqrList.get(parent).getPosition().getX() + 30, sqrList.get(parent).getPosition().getY() - 30)) // Check if no obstacle
            {
                //if (sqrList.get(parent).getPosition().getX() + 1 < 10 && sqrList.get(parent).getPosition().getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(30, -30))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getPosition().getX() + 30, sqrList.get(parent).getPosition().getY() - 30), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            // Square to the right
            if (!cb.checkWall(sqrList.get(parent).getPosition().getX() + 30, sqrList.get(parent).getPosition().getY())) // Check if no obstacle
            {
                //if (sqrList.get(parent).getPosition().getX() + 1 < 10) // Check if in bounds of grid
                    if (!check(parent, 10, new Point(30, 0))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getPosition().getX() + 30, sqrList.get(parent).getPosition().getY()), parent, sqrList.get(parent).getG(), 10, targetDestination)); // Add the square, takes 10 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            // Square to the lower right
            if (!cb.checkWall(sqrList.get(parent).getPosition().getX() + 30, sqrList.get(parent).getPosition().getY() + 30)) // Check if no obstacle
            {
                //if (sqrList.get(parent).getPosition().getX() + 1 < 10 && sqrList.get(parent).getPosition().getY() + 1 < 10) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(30, 30))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getPosition().getX() + 30, sqrList.get(parent).getPosition().getY() + 30), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            // Square below
            if (!cb.checkWall(sqrList.get(parent).getPosition().getX(), sqrList.get(parent).getPosition().getY() + 30)) // Check if no obstacle
            {
                //if (sqrList.get(parent).getPosition().getY() + 1 < 10) // Check if in bounds of grid
                    if (!check(parent, 10, new Point(0, 30))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getPosition().getX(), sqrList.get(parent).getPosition().getY() + 1), parent, sqrList.get(parent).getG(), 10, targetDestination)); // Add the square, takes 10 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            // Square lower left
            if (!cb.checkWall(sqrList.get(parent).getPosition().getX() - 30, sqrList.get(parent).getPosition().getY() + 30)) // Check if no obstacle
            {
                //if (sqrList.get(parent).getPosition().getX() - 1 > -1 && sqrList.get(parent).getPosition().getY() + 1 < 10) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(-30, 30))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getPosition().getX() - 30, sqrList.get(parent).getPosition().getY() + 30), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            sqrList.get(parent).close(); // Done looking at this square
            int lowest = -1; // Index for square that has lowest score
            for (int i = 0; i < sqrList.size(); i++) // Get square that has lowest score
            {
                if (!sqrList.get(i).checkClosed()) // Make sure we have not already looked at
                {
                    if (lowest == -1) // If havn't found one yet
                        lowest = i; // This lowest one found so far
                    else if (sqrList.get(i).getG() + sqrList.get(i).getH() < sqrList.get(lowest).getG() + sqrList.get(lowest).getH()) // Check to see if score of this square is the new lowest
                        lowest = i; // This lowest one found so far
                }
            }
            parent = lowest; // Now looking at new lowest
            for (int i = 0; i < sqrList.size(); i++) // Loop all squares that have found
            {
                if (sqrList.get(i).getPosition().equals(targetDestination) && sqrList.get(i).checkClosed()) // Check to see if found destination
                {
                    parent = i; // Start at this square to chart back to beginning
                    target = true; // We have found the destination
                }
            }
        }
        if (target) // If found destination
        {
            myRoute = new ArrayList<Square>(); // Refresh route to take
            while (parent != -1) // Loop till back to beginning
            {
                myRoute.add(sqrList.get(parent)); // Add square
                parent = sqrList.get(parent).getParent(); // Move to that square's parent
            }
            routeIndex = myRoute.size() - 2; // When start to move, starting at beginning
        }
    }
    public boolean check(int parent, int cost, Point spot)
    {
        boolean flag = false;
        for (int i = 0; i < sqrList.size(); i++) // Loop squares found
        {
            if (sqrList.get(i).getPosition().equals(new Point(sqrList.get(parent).getPosition().getX() + spot.getX(), sqrList.get(parent).getPosition().getY() + spot.getY()))) // Check if already have the square
            {
                flag = true; // Do have this square
                if (sqrList.get(i).checkClosed() && sqrList.get(parent).getG() + cost < sqrList.get(i).getG()) // Check if new route to square is better
                {
                    sqrList.get(i).adopt(parent); // Change square's parent
                    sqrList.get(i).changeG(sqrList.get(parent).getG() + cost); // Change square's score
                }
            }
        }
        return flag; // return if found that already have square
    }
    
    /*
     * Return the image rotated by the spin rotation value, for drawing
     */
    public GreenfootImage getPic()
    {
        GreenfootImage p = new GreenfootImage(health > 0 || health < -1800 ? pic : pic2);
        p.rotate(direction);
        if (health < 1)
            p.setTransparency(health > -100 ? (int)((health + 100d) / 100d * 255) : health < -1800 ? (int)(-(health + 1800d) / 200d * 255) : 0);
        return p;
    }
    
    /*
     * Return the map location x value
     */
    public int getX()
    {
        return (int)x;
    }
    
    /*
     * Return the map location y value
     */
    public int getY()
    {
        return (int)y;
    }
    
    public int getDirection()
    {
        return direction;
    }
    public int getHealth()
    {
        return health;
    }
    public void damage()
    {
        health--;
        following = 200;
    }
    public static int getWidth()
    {
        return pic.getWidth();
    }
    public static int getHeight()
    {
        return pic.getHeight();
    }
    public void shotMissle()
    {
        reload = 20;
    }
    public boolean isArmed()
    {
        if (reload > 0)
            reload--;
        return reload == 0;
    }
}