import greenfoot.*;
/**
 * Write a description of class Ship here.
 * 
 * @author Taylor Born
 * @version January 2011
 */
public class Ship extends Trailer
{
    private static GreenfootImage shipPic = new GreenfootImage("ship.png");
    private double x, y;
    private double xSpeed;
    private double ySpeed;
    private double health = 12;
    
    public Ship(Point p)
    {
        position = p;
        x = p.getX();
        y = p.getY();
        pic = new GreenfootImage(80, 80);
        pic.drawImage(shipPic, 40 - shipPic.getWidth() / 2, 40 - shipPic.getHeight() / 2);
    }
    public void throttle()
    {
        xSpeed += Math.cos(direction * Math.PI / 180) / 10;
        if (xSpeed > 5)
            xSpeed = 5;
        else if (xSpeed < -5)
            xSpeed = -5;
        ySpeed += Math.sin(direction * Math.PI / 180) / 10;
        if (ySpeed > 5)
            ySpeed = 5;
        else if (ySpeed < -5)
            ySpeed = -5;
        addTrail();
    }
    public void slow()
    {
        if (xSpeed != 0)
        {
            if (xSpeed < 0)
            {
                xSpeed += .1;
                if (xSpeed > 0)
                    xSpeed = 0;
            }
            else
            {
                xSpeed -= .1;
                if (xSpeed < 0)
                    xSpeed = 0;
            }
        }
        if (ySpeed != 0)
        {
            if (ySpeed < 0)
            {
                ySpeed += .1;
                if (ySpeed > 0)
                    ySpeed = 0;
            }
            else
            {
                ySpeed -= .1;
                if (ySpeed < 0)
                    ySpeed = 0;
            }
        }
    }
    public void go(ControlBox cb)
    {
        runTrail();
        if (cb.checkWall(x + xSpeed + (xSpeed > 0 ? 14 : -14), y))
            xSpeed *= -1 / 2d;
        if (cb.checkWall(x, y + ySpeed + (ySpeed > 0 ? 14 : -14)))
            ySpeed *= -1 / 2d;
        x += xSpeed;
        y += ySpeed;
        position = new Point((int)x, (int)y);
        if (health < 12)
            health += .01;
        else
            health = 12;
    }
    public double getHealth()
    {
        return health;
    }
    public void hurt()
    {
        health--;
    }
    public void die()
    {
        health = 0;
    }
}