/**
 * Write a description of class Square here.
 * 
 * @author Taylor Born
 * @version January 2010
 */
public class Square  
{
    private Point myPosition; // Position of square
    private int myParent; // Index of square that is before this one in the route
    private boolean isClosed = false; // Has not been looked at
    private int myG; // Score to get to this position. 10s added for every vertical and horizontal move and 14s for every diagonal move since a diagonal move is a farther move
    private int myH; // Score estimate for how many vertical and horizontal moves, regardless of obstacles

    public Square(Point position, int parent, int parentG, int thisG, Point destination)
    {
        myPosition = position; // Position
        myParent = parent; // Parent
        myG = parentG + thisG; // Parent's score plus score took to get from there to here
        myH = (int)(Math.abs(myPosition.getX() - destination.getX()) + Math.abs(myPosition.getY() - destination.getY())) * 10; // Vertical and horizontal spaces between here and destination
    }
    public Point getPosition()
    {
        return myPosition;
    }
    public int getParent()
    {
        return myParent;
    }
    public void adopt(int parent)
    {
        myParent = parent;
    }
    public boolean checkClosed()
    {
        return isClosed;
    }
    public void close()
    {
        isClosed = true;
    }
    public int getG()
    {
        return myG;
    }
    public void changeG(int newG)
    {
        myG = newG;
    }
    public int getH()
    {
        return myH;
    }
}